<?php

namespace Drupal\improvements\Access;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Routing\Access\AccessInterface;
use Drupal\Core\Routing\RouteMatchInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Route;

class UuidAccessCheck implements AccessInterface {

  /**
   * Checks access based on a uuid $_GET parameter for the request.
   */
  public function access(Route $route, RouteMatchInterface $route_match, Request $request) {
    if ($request_uuid = $request->query->get('uuid')) {
      $route_parameters = $route_match->getParameters();
      $entity = current($route_parameters->all());

      if ($entity instanceof EntityInterface && $request_uuid == $entity->uuid()) {
        return AccessResult::allowed();
      }
    }

    return AccessResult::forbidden();
  }

}
