<?php

namespace Drupal\improvements;

use Drush\Commands\DrushCommands;
use Symfony\Component\HttpFoundation\Request;

class ImprovementsDrushCommands extends DrushCommands {

  /**
   * @param string $path Path
   * @command improvements:route-info
   * @aliases route-info,ri
   */
  public function routeInfo(string $path) {
    $request = Request::create($path);
    $router = \Drupal::service('router.no_access_checks');
    try {
      $route = $router->matchRequest($request);
      $this->io()->text('Route name: ' . $route['_route']);
    }
    catch (\Exception $e) {
      $this->io()->error('No route has been found.');
    }
  }

}
