<?php

namespace Drupal\improvements;

use Drupal\Core\Entity\EntityInterface;

/**
 * Twig extensions.
 */
class ImprovementsTwigExtension extends \Twig_Extension {

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return [
      new \Twig_SimpleFunction('drupal_contact', '\Drupal\improvements\ImprovementsHelper::getContactForm'),
      new \Twig_SimpleFunction('entity_url', [$this, 'entityUrl']), // @TODO Remove after issue close https://www.drupal.org/project/drupal/issues/2907810
      new \Twig_SimpleFunction('preg_matches', [$this, 'pregMatches']),
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFilters() {
    return [
      new \Twig_SimpleFilter('format_size', 'format_size'),
    ];
  }

  /**
   * Return entity url.
   */
  public function entityUrl(EntityInterface $entity, string $rel = 'canonical', array $options = []) {
    return $entity->toUrl($rel, $options);
  }

  /**
   * Call preg_match() and return matches.
   */
  public function pregMatches(string $pattern, string $subject, int $match_index = NULL) {
    if (preg_match($pattern, $subject, $matches)) {
      if ($match_index !== NULL) {
        return $matches[$match_index] ?? NULL;
      }
      return $matches;
    }
  }

}
